# -*- coding: utf-8 -*-

from zzn_test import TestCase, TestResourceManager


class Sub(TestResourceManager):

    def __repr__(self):
        return 'Sub()'


class Res(TestResourceManager):


    def __init__(self, name):
        self.name = name
        self.clsetup = None
        self.resources = [('s', Sub())]

    def __repr__(self):
        return 'Res(%s)' % self.name

    def setUpClass(self):
        super(Res, self).setUpClass()
        self.clsetup = [self.name.upper()]

    def setUp(self):
        super(Res, self).setUp()
        return [self.name]

    def tearDownClass(self):
        super(Res, self).tearDownClass()
        self.clsetup = None

    def tearDown(self, res):
        super(Res, self).tearDown(res)
        assert res == [self.name]


class TestResourceManagers(TestCase):

    resources = [('a', Res('a')), ('b', Res('b'))]

    aid = None
    bid = None

    def test_manager1(self):
        self.assertEqual(self.a, ['a'])
        self.assertEqual(self.b, ['b'])
        a = self.resources[0][1]
        b = self.resources[1][1]
        self.assertEqual(a.clsetup, ['A'])
        self.assertEqual(b.clsetup, ['B'])
        if self.aid is None:
            self.aid = id(a.clsetup)
        else:
            self.assertEqual(self.aid, id(a.clsetup))
        if self.bid is None:
            self.bid = id(b.clsetup)
        else:
            self.assertEqual(self.bid, id(b.clsetup))

    test_manager2 = test_manager1



class TestTest(TestCase):

    def test(self):
        self.assertEqualXML(
            '<a><p /></a>',
            '<a><p></p></a>',
        )
